interface SubscriptionManagementConfiguration {
    UnsubscribeHandlingType: string;
}
export interface MessageStream {
    ID: string;
    ServerID: number;
    Name: string;
    Description: string;
    MessageStreamType: string;
    CreatedAt: string;
    UpdatedAt?: string;
    ArchivedAt?: string;
    ExpectedPurgeDate?: string;
    SubscriptionManagementConfiguration: SubscriptionManagementConfiguration;
}
export interface MessageStreams {
    MessageStreams: MessageStream[];
    TotalCount: number;
}
export interface MessageStreamArchiveResponse {
    ID: number;
    ServerID: number;
    ExpectedPurgeDate: string;
}
export interface MessageStreamUnarchiveResponse {
    ID: string;
    ServerID: number;
    Name: string;
    Description: string;
    MessageStreamType: string;
    CreatedAt: string;
    UpdatedAt?: string;
    ArchivedAt?: null;
    ExpectedPurgeDate?: string;
    SubscriptionManagementConfiguration: SubscriptionManagementConfiguration;
}
export declare class UpdateMessageStreamRequest {
    Name?: string;
    Description?: string;
    constructor(name?: string, description?: string);
}
export declare class CreateMessageStreamRequest {
    Name: string;
    Description?: string;
    ID: string;
    MessageStreamType: string;
    constructor(id: string, name: string, messageStreamType: string, description?: string);
}
export {};
